/*
  This file is part of mpro.

  mpro is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  dolt is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with dolt; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  $Id: protocol.cpp,v 1.1 2006/01/28 01:28:05 beevek Exp $

  Copyright (c) 2006 Kris Beevers
*/

/*!
  \file protocol.cpp
  \author Kris Beevers (beevek@cs.rpi.edu)
  \version $Id: protocol.cpp,v 1.1 2006/01/28 01:28:05 beevek Exp $

  \brief A wrapper for recv that implements MSG_WAITALL since
  windows doesn't support it.
 */

#include "protocol.h"
#ifndef _WIN32
  #include <sys/types.h>
  #include <sys/socket.h>
#endif

// Thanks, windows, for making us reinvent the wheel!
int sock_recv(socket_t sock, char *buf, int size)
{
  int n, tot = 0;
  do {
    n = recv(sock, buf + tot, size - tot, 0);
	if(n <= 0)
	  return n;
	tot += n;
  } while(tot != size);
  return tot;
}
